// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancyxmlsockdom.h 91 2008-01-21 14:38:55Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Small wrappers around libxml's DOM pointers.
** 
*****************************************************************************/

#ifndef FANCY_XMLSOCK_DOM_H
#define FANCY_XMLSOCK_DOM_H

#include <fancyxmlsock.h>
#include <libxml/tree.h>
#include <string>

namespace Fancy {
  namespace Sock {

    FANCYXMLSOCK_API xmlNodePtr findFirstChildNode(xmlNodePtr d, const xmlChar *name);
    FANCYXMLSOCK_API xmlNodePtr findNextChildNode(xmlNodePtr d, const xmlChar *name);

    class FANCYXMLSOCK_API DomDoc
    {
      xmlDocPtr doc;

    public:
      DomDoc() : doc(0) {}
      DomDoc(xmlDocPtr d) : doc(d) {}

      ~DomDoc() { if(doc) xmlFreeDoc(doc); }

      xmlDocPtr xml_doc() const { return doc; }
      xmlDocPtr release() { xmlDocPtr ret=doc; doc=0; return ret; }
    
      DomDoc &reset(xmlDocPtr d)
      { if(doc) xmlFreeDoc(doc); doc = d; return *this; }
    };

    class FANCYXMLSOCK_API DomNode
    {
      xmlNodePtr node;

    public:
      DomNode() : node(0) {}
      DomNode(xmlNodePtr n) : node(n) {}
      DomNode(xmlDocPtr d, const xmlChar *name);

      ~DomNode() { if(node) xmlFreeNode(node); }

      xmlNodePtr xml_node() const { return node; }
      xmlNodePtr release() { xmlNodePtr ret=node; node=0; return ret; }
 
      void newProp (const xmlChar *key, const xmlChar *v);
      void newProp (const xmlChar *key, const std::string &v);
      void newProp (const xmlChar *key, const char *fmt, ...);
   
      DomNode &reset(xmlNodePtr n)
      { if(node) xmlFreeNodeList(node); node = n; return *this; }
    };

  }
}

#endif
