// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancyxmlsockencoding.h 91 2008-01-21 14:38:55Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Base functionality for handling character encodings.
** 
*****************************************************************************/

#ifndef FANCY_XMLSOCK_ENCODING_H
#define FANCY_XMLSOCK_ENCODING_H

#include <fancyxmlsock.h>
#include <string>

namespace Fancy {
  namespace Sock {

    class FANCYXMLSOCK_API XmlString
    {
      unsigned char *str;

    public:
      XmlString();
      XmlString(const unsigned char *s);
      XmlString(unsigned char *s);
      XmlString(const XmlString &s);

      ~XmlString();

      unsigned char operator[] (int i) const { return str[i]; }

      const unsigned char *xml_str() const { return str; }
      unsigned char *release() { unsigned char *ret=str; str=0; return ret; }

      XmlString &reset(unsigned char *str);
      XmlString &dup(const unsigned char *str);

      XmlString &operator= (const XmlString &s) { return dup(s.xml_str()); }

    };

    FANCYXMLSOCK_API unsigned char *isolat1ToUtf8 (const char *lat);
    inline unsigned char *isolat1ToUtf8 (const std::string &lat)
    { return isolat1ToUtf8(lat.c_str()); }

    FANCYXMLSOCK_API std::string utf8ToIsolat1 (const unsigned char *utf8);
    inline std::string utf8ToIsolat1 (const XmlString &utf8)
    { return utf8ToIsolat1 (utf8.xml_str()); }
  }
}
#endif
