// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancyxmlsockprotocol.h 91 2008-01-21 14:38:55Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** A base class, which wraps a socket protocol for communicationg XML.
** Extensible for using HTTP etc. by using virtual functions.
** 
*****************************************************************************/

#ifndef FANCY_XMLSOCK_PROTOCOL_H
#define FANCY_XMLSOCK_PROTOCOL_H

#include <fancyxmlsock.h>
#include <libxml/xmlIO.h>

namespace Fancy {
  namespace Sock {
    
    class Transport;

    class FANCYXMLSOCK_API Protocol
    {
    public:
      Protocol(Transport *d, xmlCharEncoding encoding=XML_CHAR_ENCODING_UTF8);

      virtual ~Protocol();

      virtual void writeXmlDoc (xmlDocPtr doc);
      virtual xmlDocPtr readXmlDoc ();

      Transport *getTransport() const;
 
    protected:
      void setXmlEncoding(xmlCharEncoding encoding);

      void writeToTransport(xmlDocPtr doc);
      xmlDocPtr readFromTransport();
    
    private:
      Transport *transport;
      xmlCharEncoding xml_encoding;
      
      Protocol (const Protocol &);
      Protocol &operator=(const Protocol &);
    };
  }
}

#endif // ! FANCY_XMLSOCK_PROTOCOL_H
